#include "cppuhelper/implementationentry.hxx"
#include "com/sun/star/lang/XMultiServiceFactory.hpp"
#include "com/sun/star/registry/XRegistryKey.hpp"
#include "com/sun/star/container/XNamed.hpp"
#include "comphelper/servicedecl.hxx"
#include <cppuhelper/implbase1.hxx>

// =============================================================================
// component exports
// =============================================================================
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;

namespace sdecl = comphelper::service_decl;

// reference service helper(s)
namespace  testNames
{

typedef ::cppu::WeakImplHelper1< container::XNamed > Named_BASE;

static rtl::OUString TEST_STRING( RTL_CONSTASCII_USTRINGPARAM("Test") );

class TestNamesComp : public Named_BASE
{
    rtl::OUString msName;
public:
    TestNamesComp( const uno::Reference<uno::XComponentContext>& )
    {
        msName = TEST_STRING;
    }
    // Methods
    virtual ::rtl::OUString SAL_CALL getName() throw (uno::RuntimeException)
    {
        return msName;
    }
    virtual void SAL_CALL setName( const ::rtl::OUString& aName ) throw (uno::RuntimeException)
    {
        msName = aName;	
    }
	
};

sdecl::class_<TestNamesComp, sdecl::with_args<false> > serviceImpl;
extern sdecl::ServiceDecl const serviceDecl(
    serviceImpl,
#ifdef DISABLE_PROBLEM // different impl name causes problem for extension manager
    "org.openoffice.test.Names",
#else
    "TestNamesComp",
#endif
    "org.openoffice.test.Names" );
}

extern "C"
{
    void SAL_CALL component_getImplementationEnvironment( 
        const sal_Char ** ppEnvTypeName, uno_Environment ** /*ppEnv*/ )
    {
		OSL_TRACE("In component_getImplementationEnv");
        *ppEnvTypeName = CPPU_CURRENT_LANGUAGE_BINDING_NAME;
    }

    sal_Bool SAL_CALL component_writeInfo( 
        lang::XMultiServiceFactory * pServiceManager, registry::XRegistryKey * pRegistryKey )
    {
		OSL_TRACE("In component_writeInfo");

	// Component registration
        if ( component_writeInfoHelper( pServiceManager, pRegistryKey, 
		testNames::serviceDecl ) )
		{
			// Singleton registration
			try
			{
				registry::XRegistryKey * pKey =
					reinterpret_cast< registry::XRegistryKey * >(pRegistryKey);

				Reference< registry::XRegistryKey >xKey = pKey->createKey(
					rtl::OUString::createFromAscii( ("org.openoffice.test.Names/UNO/SINGLETONS/org.openoffice.test.theNames") ) );
				xKey->setStringValue( ::rtl::OUString::createFromAscii( 
					("org.openoffice.test.Names") ) );
				return sal_True;
			}
			catch( uno::Exception& /*e*/ )
			{
				//recomp & friends will detect false returned and fail
			}
		}
		return sal_False;
    }

    void * SAL_CALL component_getFactory( 
        const sal_Char * pImplName, lang::XMultiServiceFactory * pServiceManager,
        registry::XRegistryKey * pRegistryKey )
    {
		OSL_TRACE("In component_getFactory for %s", pImplName );
	void* pRet =  component_getFactoryHelper(
        	pImplName, pServiceManager, pRegistryKey,  testNames::serviceDecl );
	OSL_TRACE("Ret is 0x%x", pRet);
	return pRet;
    }
}
